diff --git a/src/QABugs/QABugs_11.cxx b/src/QABugs/QABugs_11.cxx
index 03b79bb..269c93d 100644
--- a/src/QABugs/QABugs_11.cxx
+++ b/src/QABugs/QABugs_11.cxx
@@ -1095,96 +1095,6 @@ static Standard_Integer OCC363 (Draw_Interpretor& di, Standard_Integer argc, con
 //  return 0;
 //}
 
-#include <BRepTopAdaptor_FClass2d.hxx>
-
-//======================================================================================
-// Function : OCC377
-// Purpose  :
-//======================================================================================
-static Standard_Integer OCC377 (Draw_Interpretor& di, Standard_Integer argc, const char ** argv)
-{
-  try
-  {
-    OCC_CATCH_SIGNALS
-    // 1. Verify validity of arguments
-    if ( argc < 1 ) {di << "Error OCC377. Use  OCC377 file x y precuv \n";return 0;}
-
-    // 2. Initialize parameters
-    gp_Pnt2d p2d;
-    p2d.SetX ( Draw::Atof(argv[2]) );
-    p2d.SetY ( Draw::Atof(argv[3]) );
-    Standard_Real precuv = Draw::Atof (argv[4] );
-
-    // 3. Read shape
-    BRep_Builder B;
-    TopoDS_Shape Shape;
-    BRepTools::Read ( Shape, argv[1], B );
-
-    // 4. Verify whether enrtry point is on wire and reversed ones (indeed results of veridying must be same)
-    TopExp_Explorer exp;
-    Standard_Integer i=1;
-    for (exp.Init(Shape.Oriented(TopAbs_FORWARD),TopAbs_WIRE); exp.More(); exp.Next(), i++)
-    {
-      // 4.1. Verify whether enrtry point is on wire
-      const TopoDS_Wire& wir = TopoDS::Wire(exp.Current());
-      TopoDS_Face newFace = TopoDS::Face(Shape.EmptyCopied());
-
-      TopAbs_Orientation orWire = wir.Orientation();
-      newFace.Orientation(TopAbs_FORWARD);
-      B.Add(newFace,wir);
-
-      BRepTopAdaptor_FClass2d FClass2d1(newFace,precuv);
-      TopAbs_State stat1 = FClass2d1.PerformInfinitePoint();
-      //di << "Wire " << i << ": Infinite point is " <<
-      //  ( stat1 == TopAbs_IN ? "IN" : stat1 == TopAbs_OUT ? "OUT" : stat1 == TopAbs_ON ? "ON" : "UNKNOWN" ) << "\n";
-
-      TCollection_AsciiString TmpString;
-      stat1 == TopAbs_IN ? TmpString.AssignCat("IN") : stat1 == TopAbs_OUT ? TmpString.AssignCat("OUT") : stat1 == TopAbs_ON ? TmpString.AssignCat("ON") : TmpString.AssignCat("UNKNOWN");
-      di << "Wire " << i << ": Infinite point is " << TmpString.ToCString() << "\n";
-
-      stat1 = FClass2d1.Perform(p2d);
-      //di << "Wire " << i << ": point ( " << p2d.X() << ", " << p2d.Y() << " ) is " <<
-      //  ( stat1 == TopAbs_IN ? "IN" : stat1 == TopAbs_OUT ? "OUT" : stat1 == TopAbs_ON ? "ON" : "UNKNOWN" ) << "\n";
-
-      TmpString.Clear();
-      stat1 == TopAbs_IN ? TmpString.AssignCat("IN") : stat1 == TopAbs_OUT ? TmpString.AssignCat("OUT") : stat1 == TopAbs_ON ? TmpString.AssignCat("ON") : TmpString.AssignCat("UNKNOWN");
-      di << "Wire " << i << ": point ( " << p2d.X() << ", " << p2d.Y() << " ) is " << TmpString.ToCString() << "\n";
-
-      // 4.2. Verify whether enrtry point is on reversed wire
-      newFace = TopoDS::Face(Shape.EmptyCopied());
-      newFace.Orientation(TopAbs_FORWARD);
-      orWire = TopAbs::Reverse(orWire);
-      B.Add(newFace,wir.Oriented(orWire));
-      BRepTopAdaptor_FClass2d FClass2d2(newFace,precuv);
-      TopAbs_State stat2 = FClass2d2.PerformInfinitePoint();
-      //di << "Reversed Wire " << i << ": Infinite point is " <<
-      //  ( stat2 == TopAbs_IN ? "IN" : stat2 == TopAbs_OUT ? "OUT" : stat2 == TopAbs_ON ? "ON" : "UNKNOWN" ) << "\n";
-
-      TmpString.Clear();
-      stat2 == TopAbs_IN ? TmpString.AssignCat("IN") : stat2 == TopAbs_OUT ? TmpString.AssignCat("OUT") : stat2 == TopAbs_ON ? TmpString.AssignCat("ON") : TmpString.AssignCat("UNKNOWN");
-      di << "Reversed Wire " << i << ": Infinite point is " << TmpString.ToCString() << "\n";
-
-      stat2 = FClass2d2.Perform(p2d);
-      //di << "Reversed Wire " << i << ": point ( " << p2d.X() << ", " << p2d.Y() << " ) is " <<
-      //  ( stat2 == TopAbs_IN ? "IN" : stat2 == TopAbs_OUT ? "OUT" : stat2 == TopAbs_ON ? "ON" : "UNKNOWN" ) << "\n";
-
-      TmpString.Clear();
-      stat2 == TopAbs_IN ? TmpString.AssignCat("IN") : stat2 == TopAbs_OUT ? TmpString.AssignCat("OUT") : stat2 == TopAbs_ON ? TmpString.AssignCat("ON") : TmpString.AssignCat("UNKNOWN");
-      di << "Reversed Wire " << i << ": point ( " << p2d.X() << ", " << p2d.Y() << " ) is " << TmpString.ToCString() << "\n";
-
-      // 4.3. Compare results (they must be same)
-      if(stat1 ==stat2) di << "OCC377 OK\n";
-      else {di << "OCC377 FAULTY\n"; return 0;}
-    }
-  }
-  catch(Standard_Failure)
-  {
-    di << "OCC377 Exception";
-  }
-
-  return 0;
-}
-
 #include <ShapeUpgrade_ShapeDivideAngle.hxx>
 #include <ShapeBuild_ReShape.hxx>
 
@@ -4838,7 +4748,6 @@ void QABugs::Commands_11(Draw_Interpretor& theCommands) {
   theCommands.Add("OCC363", "OCC363 document filename ", __FILE__, OCC363, group);
   // Must use OCC299
   //theCommands.Add("OCC372", "OCC372", __FILE__, OCC372, group);
-  theCommands.Add("OCC377", "OCC377", __FILE__, OCC377, group);
   theCommands.Add("OCC22", "OCC22 Result Shape CompoundOfSubshapesToBeDivided ConsiderLocation", __FILE__, OCC22, group);
   theCommands.Add("OCC24", "OCC24 Result Shape CompoundOfSubshapes ResourceFileName", __FILE__, OCC24, group);
   theCommands.Add("OCC369", "OCC369 Shape", __FILE__, OCC369, group);
diff --git a/src/QABugs/QABugs_8.cxx b/src/QABugs/QABugs_8.cxx
index 075003b..13c61df 100644
--- a/src/QABugs/QABugs_8.cxx
+++ b/src/QABugs/QABugs_8.cxx
@@ -142,7 +142,7 @@ static Standard_Integer OCC1651 (Draw_Interpretor& di, Standard_Integer argc, co
   gp_Dir aD1(Draw::Atof(argv[5]), Draw::Atof(argv[6]), Draw::Atof(argv[7]));
   gp_Lin aL1(aP1,aD1);
   BRepClass3d_Intersector3d aI1;
-  aI1.Perform(aL1, -250, 1e-7, TopoDS::Face(aShape));
+  aI1.Perform(aL1, 1e-7, TopoDS::Face(aShape));
   if(aI1.IsDone() && aI1.HasAPoint()) {
     gp_Pnt aR1 = aI1.Pnt();
     di << aR1.X() << " " << aR1.Y() << " " << aR1.Z() << "\n";
diff --git a/src/RWStepVisual/RWStepVisual_RWPresentationLayerAssignment.cxx b/src/RWStepVisual/RWStepVisual_RWPresentationLayerAssignment.cxx
index 2cf4d65..736764f 100644
--- a/src/RWStepVisual/RWStepVisual_RWPresentationLayerAssignment.cxx
+++ b/src/RWStepVisual/RWStepVisual_RWPresentationLayerAssignment.cxx
@@ -54,7 +54,7 @@ void RWStepVisual_RWPresentationLayerAssignment::ReadStep
 	Standard_Integer nsub3;
 	if (data->ReadSubList (num,3,"assigned_items",ach,nsub3)) {
 	  Standard_Integer nb3 = data->NbParams(nsub3);
-	  aAssignedItems = new StepVisual_HArray1OfLayeredItem (1, nb3);
+	  aAssignedItems = new StepVisual_HArray1OfLayeredItem (1, Max(nb3, 1));
 	  for (Standard_Integer i3 = 1; i3 <= nb3; i3 ++) {
 	    //szv#4:S4163:12Mar99 `Standard_Boolean stat3 =` not needed
 	    if (data->ReadEntity (nsub3,i3,"assigned_items",ach,aAssignedItemsItem))
diff --git a/src/SWDRAW/SWDRAW_ShapeAnalysis.cxx b/src/SWDRAW/SWDRAW_ShapeAnalysis.cxx
index 53452db..078cee6 100644
--- a/src/SWDRAW/SWDRAW_ShapeAnalysis.cxx
+++ b/src/SWDRAW/SWDRAW_ShapeAnalysis.cxx
@@ -18,6 +18,7 @@
 
 #include <BRep_Builder.hxx>
 #include <BRep_Tool.hxx>
+#include <BRepAdaptor_Surface.hxx>
 #include <BRepBuilderAPI.hxx>
 #include <BRepBuilderAPI_MakeFace.hxx>
 #include <BRepGProp.hxx>
@@ -316,6 +317,8 @@ static Standard_Integer anaface
     di<<"\n";
   }
   else { di<<"Analyse Wires, Ignore Faces\n"; }
+
+  const Standard_Real aTolF = BRep_Tool::Tolerance(Face);
   Standard_Boolean iasurf = !surface.IsNull();
 //:sw  if (!Face.IsNull()) STW.SetFace (Face);
 //:sw  else STW.SetPrecision (BRepBuilderAPI::Precision());
@@ -432,7 +435,7 @@ static Standard_Integer anaface
       if (G.Mass() > 0) di<<"GProps:Mass Out\n";
       else di<<"GProps:Mass In\n";
 ///  return (G.Mass() > 0);
-      BRepTopAdaptor_FClass2d fcl (Face,BRep_Tool::Tolerance(Face));
+      BRepTopAdaptor_FClass2d fcl(Face, aTolF);
       if (fcl.PerformInfinitePoint () == TopAbs_OUT) di<<"Classifier Infinite : Out\n";
       else di<<"Classifier Infinite : In\n";
       gp_Pnt2d pcl;
diff --git a/src/ShapeAnalysis/ShapeAnalysis.cxx b/src/ShapeAnalysis/ShapeAnalysis.cxx
index fdc65a7..a4bef1e 100644
--- a/src/ShapeAnalysis/ShapeAnalysis.cxx
+++ b/src/ShapeAnalysis/ShapeAnalysis.cxx
@@ -230,10 +230,8 @@ Standard_Boolean ShapeAnalysis::IsOuterBound(const TopoDS_Face& face)
     return (totcross >= 0);
   }
   else {
-    BRepAdaptor_Surface Ads ( F, Standard_False ); 
-    Standard_Real tol = BRep_Tool::Tolerance(F);
-    Standard_Real toluv = Min ( Ads.UResolution(tol), Ads.VResolution(tol) );
-    BRepTopAdaptor_FClass2d fcl (F,toluv);
+    const Standard_Real aTol = BRep_Tool::Tolerance(F);
+    BRepTopAdaptor_FClass2d fcl(F, aTol);
     Standard_Boolean rescl = (fcl.PerformInfinitePoint () == TopAbs_OUT);
     return rescl;
   }
diff --git a/src/ShapeFix/ShapeFix_ComposeShell.cxx b/src/ShapeFix/ShapeFix_ComposeShell.cxx
index 9afe4ff..e322048 100644
--- a/src/ShapeFix/ShapeFix_ComposeShell.cxx
+++ b/src/ShapeFix/ShapeFix_ComposeShell.cxx
@@ -2433,7 +2433,7 @@ void ShapeFix_ComposeShell::MakeFacesOnPatch (TopTools_SequenceOfShape &faces,
       TopoDS_Face fc;
       B.MakeFace ( fc, surf, myLoc, ::Precision::Confusion() );
       B.Add ( fc, awtmp );
-      BRepTopAdaptor_FClass2d clas ( fc, ::Precision::PConfusion() );
+      BRepTopAdaptor_FClass2d clas ( fc, Precision::Confusion() );
       TopAbs_State stPoint = clas.Perform (unp,Standard_False);
       if(stPoint == TopAbs_ON || stPoint == TopAbs_UNKNOWN) {
 
@@ -2486,7 +2486,7 @@ void ShapeFix_ComposeShell::MakeFacesOnPatch (TopTools_SequenceOfShape &faces,
     TopoDS_Face fc;
     B.MakeFace ( fc, surf, myLoc, ::Precision::Confusion() );
     B.Add ( fc, wire );
-    BRepTopAdaptor_FClass2d clas ( fc, ::Precision::PConfusion() );
+    BRepTopAdaptor_FClass2d clas ( fc, Precision::Confusion() );
     if ( clas.PerformInfinitePoint() == TopAbs_IN ) {
       reverse = Standard_True;
 #ifdef OCCT_DEBUG
diff --git a/src/ShapeFix/ShapeFix_Face.cxx b/src/ShapeFix/ShapeFix_Face.cxx
index 9ebadf5..31020de 100644
--- a/src/ShapeFix/ShapeFix_Face.cxx
+++ b/src/ShapeFix/ShapeFix_Face.cxx
@@ -1195,12 +1195,8 @@ Standard_Boolean ShapeFix_Face::FixOrientation(TopTools_DataMapOfShapeListOfShap
 //      B.MakeFace (af,mySurf->Surface(),::Precision::Confusion());
       af.Orientation ( TopAbs_FORWARD );
       B.Add (af,aw);
-      // PTV OCC945 06.11.2002 files ie_exhaust-A.stp (entities 3782,  3787)
-      // tolerance is too big. It is seems that to identify placement of 2d point
-      // it is enough Precision::PConfusion(), cause wea re know that 2d point in TopAbs_ON
-      // BRepTopAdaptor_FClass2d clas (af,toluv);
       Standard_Boolean CheckShift = Standard_True;
-      BRepTopAdaptor_FClass2d clas (af,::Precision::PConfusion());
+      BRepTopAdaptor_FClass2d clas (af, 0.0);
       TopAbs_State sta = TopAbs_OUT;
       TopAbs_State staout = clas.PerformInfinitePoint();
       TopTools_ListOfShape IntWires;
@@ -2438,7 +2434,7 @@ Standard_Boolean ShapeFix_Face::FixSplitFace(const TopTools_DataMapOfShapeListOf
         TopoDS_Face aFace = TopoDS::Face ( aShapeEmptyCopied);
         aFace.Orientation ( TopAbs_FORWARD );
         B.Add (aFace,liter.Value());
-        BRepTopAdaptor_FClass2d clas (aFace,::Precision::PConfusion());
+        BRepTopAdaptor_FClass2d clas (aFace, 0.0);
         TopAbs_State staout = clas.PerformInfinitePoint();
         if (staout == TopAbs_IN) 
           B.Add(tmpFace,liter.Value());
diff --git a/src/TNaming/TNaming.cxx b/src/TNaming/TNaming.cxx
index d4a0bc1..5d5fd4a 100644
--- a/src/TNaming/TNaming.cxx
+++ b/src/TNaming/TNaming.cxx
@@ -17,10 +17,11 @@
 
 #include <BRep_Builder.hxx>
 #include <BRep_Tool.hxx>
+#include <BRepAdaptor_Surface.hxx>
 #include <BRepBuilderAPI_Transform.hxx>
 #include <BRepClass3d_SolidClassifier.hxx>
+#include <BRepTopAdaptor_FClass2d.hxx>
 #include <gp_Trsf.hxx>
-#include <IntTools_FClass2d.hxx>
 #include <TColStd_IndexedDataMapOfTransientTransient.hxx>
 #include <TDF_ChildIterator.hxx>
 #include <TDF_Label.hxx>
@@ -917,16 +918,17 @@ Standard_Boolean TNaming::OuterWire(const TopoDS_Face& theFace, TopoDS_Wire& the
   TopoDS_Face aFx;
   TopoDS_Wire aWx;
   BRep_Builder aBB;
-  IntTools_FClass2d aFC;
+  BRepTopAdaptor_FClass2d aFC;
   Standard_Boolean bFlag(Standard_False);
-  Standard_Real aTol = BRep_Tool::Tolerance(theFace);
+  Standard_Real aTolF = BRep_Tool::Tolerance(theFace);
+
   TopoDS_Iterator aIt(theFace);
   for (; aIt.More(); aIt.Next()) {
     aWx=*((TopoDS_Wire*)&aIt.Value());
     aFx = theFace;
     aFx.EmptyCopy();
     aBB.Add(aFx, aWx);
-    aFC.Init(aFx, aTol);
+    aFC.Init(aFx, aTolF);
     bFlag = aFC.IsHole();
     if (!bFlag) 
       break;
diff --git a/src/TopClass/FILES b/src/TopClass/FILES
index b6b1e48..527e043 100755
--- a/src/TopClass/FILES
+++ b/src/TopClass/FILES
@@ -4,7 +4,11 @@ TopClass_Classifier2d.lxx
 TopClass_Classifier3d.gxx
 TopClass_Classifier3d.lxx
 TopClass_FaceClassifier.gxx
-TopClass_FaceClassifier.lxx
+TopClass_GeomEdge.cxx
+TopClass_GeomEdge.hxx
+TopClass_GeomVertex.cxx
+TopClass_GeomVertex.hxx
+TopClass_RayInfo.hxx
 TopClass_SolidClassifier.gxx
 TopClass_SolidExplorer.cxx
 TopClass_SolidExplorer.hxx
diff --git a/src/TopClass/TopClass_Classifier2d.gxx b/src/TopClass/TopClass_Classifier2d.gxx
index 22f46b3..f690452 100644
--- a/src/TopClass/TopClass_Classifier2d.gxx
+++ b/src/TopClass/TopClass_Classifier2d.gxx
@@ -19,10 +19,8 @@
 
 //  Modified by skv - Wed Jul 12 15:20:58 2006 OCC12627
 
-
-#include <IntRes2d_IntersectionSegment.hxx>
-#include <IntRes2d_IntersectionPoint.hxx>
-#include <gp_Vec2d.hxx>
+#include <GeomLib.hxx>
+#include <TopClass_GeomEdge.hxx>
 
 //=======================================================================
 //function : TopClass_Classifier2d
@@ -30,7 +28,6 @@
 //=======================================================================
 
 TopClass_Classifier2d::TopClass_Classifier2d() :
-       myIsSet(Standard_False),
        myFirstCompare(Standard_True),
        myState(TopAbs_UNKNOWN),      // skv OCC12627
        myIsHeadOrEnd(Standard_False) // skv OCC12627
@@ -42,18 +39,15 @@ TopClass_Classifier2d::TopClass_Classifier2d() :
 //purpose  : 
 //=======================================================================
 
-void TopClass_Classifier2d::Reset(const gp_Lin2d& L,  
-				  const Standard_Real P,
-				  const Standard_Real Tol)
+void TopClass_Classifier2d::Reset(const gp_Lin2d& L,
+                                  const Standard_Real P)
 {
   myLin = L;
   myParam = P;
-  myTolerance = Tol;
   myState = TopAbs_UNKNOWN;
   myFirstCompare = Standard_True;
   myFirstTrans = Standard_True;
   myClosest = 0;
-  myIsSet = Standard_True;
 //  Modified by skv - Wed Jul 12 15:20:58 2006 OCC12627 Begin
   myIsHeadOrEnd = Standard_False;
 //  Modified by skv - Wed Jul 12 15:20:58 2006 OCC12627 End
@@ -64,12 +58,17 @@ void TopClass_Classifier2d::Reset(const gp_Lin2d& L,
 //purpose  : 
 //=======================================================================
 
-void TopClass_Classifier2d::Compare(const TheEdge& E,
-				    const TopAbs_Orientation Or)
+void TopClass_Classifier2d::Compare(const TopClass_GeomEdge& theE,
+                                    const Standard_Real theTol2D)
 {
+  // if the Edge is INTERNAL or EXTERNAL, no problem
+  if ((theE.GetOrientation() != TopAbs_FORWARD) && 
+      (theE.GetOrientation() != TopAbs_REVERSED))
+    return;
+
   // intersect the edge and the segment
   myClosest = 0;
-  myIntersector.Perform(myLin,myParam,myTolerance,E);
+  myIntersector.Perform(myLin, myParam, theTol2D, theE);
   if (!myIntersector.IsDone()) return;
   if ((myIntersector.NbPoints()   == 0)&&
       (myIntersector.NbSegments() == 0)) return;
@@ -119,17 +118,6 @@ void TopClass_Classifier2d::Compare(const TheEdge& E,
   // if no point was found return
   if (myClosest == 0) return;
 
-  // if the Edge is INTERNAL or EXTERNAL, no problem
-  if (Or == TopAbs_INTERNAL) {
-    myState = TopAbs_IN;
-    return;
-  }
-  else if (Or == TopAbs_EXTERNAL) {
-    myState = TopAbs_OUT;
-    return;
-  }
-
-
   if ( ! myFirstCompare ) {
     Standard_Boolean b = (dMin > myParam);
     if (b) {
@@ -161,29 +149,38 @@ void TopClass_Classifier2d::Compare(const TheEdge& E,
   TopAbs_Orientation SegTrans = TopAbs_FORWARD;
 
   const IntRes2d_Transition& T1 = PClosest->TransitionOfFirst();
-  switch (T1.TransitionType()) {
-  case IntRes2d_In :
-    if (Or == TopAbs_REVERSED)   SegTrans = TopAbs_REVERSED;
-    else                         SegTrans = TopAbs_FORWARD;
+  switch (T1.TransitionType())
+  {
+  case IntRes2d_In:
+    SegTrans = theE.GetOrientation();
     break;
-  case IntRes2d_Out :
-    if (Or == TopAbs_REVERSED)   SegTrans = TopAbs_FORWARD;
-    else                         SegTrans = TopAbs_REVERSED;
+  case IntRes2d_Out:
+    if (theE.GetOrientation() == TopAbs_REVERSED)
+      SegTrans = TopAbs_FORWARD;
+    else
+      SegTrans = TopAbs_REVERSED;
     break;
-  case IntRes2d_Touch :
-    switch (T1.Situation()) {
-    case IntRes2d_Inside :
-      if (Or == TopAbs_REVERSED) SegTrans = TopAbs_EXTERNAL;
-      else                       SegTrans = TopAbs_INTERNAL;
+  case IntRes2d_Touch:
+    switch (T1.Situation())
+    {
+    case IntRes2d_Inside:
+      if (theE.GetOrientation() == TopAbs_REVERSED)
+        SegTrans = TopAbs_EXTERNAL;
+      else
+        SegTrans = TopAbs_INTERNAL;
       break;
-    case IntRes2d_Outside :
-      if (Or == TopAbs_REVERSED) SegTrans = TopAbs_INTERNAL;
-      else                       SegTrans = TopAbs_EXTERNAL;
+    case IntRes2d_Outside:
+      if (theE.GetOrientation() == TopAbs_REVERSED)
+        SegTrans = TopAbs_INTERNAL;
+      else
+        SegTrans = TopAbs_EXTERNAL;
       break;
-    case IntRes2d_Unknown :      return;
+    case IntRes2d_Unknown:
+      return;
     }
     break;
-  case IntRes2d_Undecided :      return;
+  case IntRes2d_Undecided:
+    return;
   }
 
   // are we inside the Edge ?
@@ -207,8 +204,13 @@ void TopClass_Classifier2d::Compare(const TheEdge& E,
     // PClosest is Head or End of the edge : update the complex transition
     gp_Dir2d Tang2d,Norm2d;
     Standard_Real Curv;
-    myIntersector.LocalGeometry
-      (E,PClosest->ParamOnSecond(),Tang2d,Norm2d,Curv);
+    if(!GeomLib::LocalGeometry(theE.Get2DCurve().Curve(),
+                               PClosest->ParamOnSecond(),
+                               Tang2d, Norm2d, Curv))
+    {
+      return;
+    }
+
     gp_Dir Tang(Tang2d.X(),Tang2d.Y(),0.);
     gp_Dir Norm(Norm2d.X(),Norm2d.Y(),0.);
     if (myFirstTrans) {
diff --git a/src/TopClass/TopClass_Classifier3d.gxx b/src/TopClass/TopClass_Classifier3d.gxx
index a5a77b0..8eef1d2 100644
--- a/src/TopClass/TopClass_Classifier3d.gxx
+++ b/src/TopClass/TopClass_Classifier3d.gxx
@@ -43,7 +43,7 @@ void TopClass_Classifier3d::Compare(const TopoDS_Face&        Face,
   }
 
   hasIntersect = Standard_False;
-  myIntersector.Perform(myLin,myParam,myTolerance,Face);
+  myIntersector.Perform(myLin,myTolerance,Face);
   if(myIntersector.IsDone()) { 
     if(myIntersector.HasAPoint()) { 
       hasIntersect = Standard_True;
diff --git a/src/TopClass/TopClass_FaceClassifier.gxx b/src/TopClass/TopClass_FaceClassifier.gxx
index 7f86749..ee76a4c 100644
--- a/src/TopClass/TopClass_FaceClassifier.gxx
+++ b/src/TopClass/TopClass_FaceClassifier.gxx
@@ -17,138 +17,192 @@
 //  Modified by skv - Thu Jul 13 18:00:34 2006 OCC12627
 // The method Perform is totally rewroted.
 
-#include <IntRes2d_IntersectionSegment.hxx>
-#include <IntRes2d_IntersectionPoint.hxx>
+#include <algorithm>
 
-//=======================================================================
-//function : TopClass_FaceClassifier
-//purpose  : 
-//=======================================================================
-
-TopClass_FaceClassifier::TopClass_FaceClassifier() :
-myEdgeParameter(0.0),
-rejected(Standard_False),
-nowires(Standard_True)
-{
-}
+#include <BRep_Tool.hxx>
+#include <NCollection_Array1.hxx>
+#include <TopClass_RayInfo.hxx>
 
 //=======================================================================
 //function : TopClass_FaceClassifier
 //purpose  : 
 //=======================================================================
-
-TopClass_FaceClassifier::TopClass_FaceClassifier(TheFaceExplorer& FExp,
-						 const gp_Pnt2d& P,
-						 const Standard_Real Tol) :
+TopClass_FaceClassifier::TopClass_FaceClassifier() :
 myEdgeParameter(0.0),
-rejected(Standard_False),
-nowires(Standard_True)
+myState(TopAbs_UNKNOWN)
 {
-  Perform(FExp,P,Tol);
 }
 
 //=======================================================================
 //function : Perform
 //purpose  : 
 //=======================================================================
-
-void TopClass_FaceClassifier::Perform(TheFaceExplorer& Fexp,
-				      const gp_Pnt2d& P,
-				      const Standard_Real Tol)
+void TopClass_FaceClassifier::Perform(TheFaceExplorer& theFExp,
+                                      const gp_Pnt2d& theP,
+                                      const Standard_Real theTol2D)
 {
-  gp_Pnt2d aPoint(P);
+  myEdge = TopClass_GeomEdge();
+  myEdgeParameter = 0.0;
+  myState = TopAbs_UNKNOWN;
+
+  gp_Pnt2d aPoint(theP);
   Standard_Boolean aResOfPointCheck = Standard_False;
   while (aResOfPointCheck == Standard_False)
   {
-    aResOfPointCheck = Fexp.CheckPoint(aPoint);
+    aResOfPointCheck = theFExp.CheckPoint(aPoint);
   }
 
-  // Test for rejection.
-  rejected = Fexp.Reject(aPoint);
-
-  if (rejected)
-    return;
+  TopClass_GeomEdge          anEdge;
 
-  gp_Lin2d                   aLine;
-  Standard_Real              aParam;
-  Standard_Boolean           IsValidSegment = Fexp.Segment(aPoint, aLine, aParam);
-  TheEdge                    anEdge;
-  TopAbs_Orientation         anEdgeOri;
   Standard_Integer           aClosestInd;
   IntRes2d_IntersectionPoint aPInter;
-  TopAbs_State               aState = TopAbs_UNKNOWN;
-  Standard_Boolean           IsWReject;
-  Standard_Boolean           IsEReject;
-
-  nowires = Standard_True;
-
-  while (IsValidSegment) {
-    myClassifier.Reset(aLine, aParam, Tol);
-
-    for (Fexp.InitWires(); Fexp.MoreWires(); Fexp.NextWire()) {
-      nowires   = Standard_False;
-      IsWReject = Fexp.RejectWire(aLine, myClassifier.Parameter());
-
-      if (!IsWReject) {
-	// test this wire
-	for (Fexp.InitEdges(); Fexp.MoreEdges(); Fexp.NextEdge()) {
-	  IsEReject = Fexp.RejectEdge(aLine, myClassifier.Parameter());
-
-	  if (!IsEReject) {
-	    // test this edge
-	    Fexp.CurrentEdge(anEdge, anEdgeOri);
-
-	    if (anEdgeOri == TopAbs_FORWARD || anEdgeOri == TopAbs_REVERSED) {
-	      myClassifier.Compare(anEdge, anEdgeOri);
-	      aClosestInd = myClassifier.ClosestIntersection();
-
-	      if (aClosestInd != 0) {
-		// save the closest edge
-		TheIntersection2d &anIntersector = myClassifier.Intersector();
-		Standard_Integer   aNbPnts       = anIntersector.NbPoints();
-
-		myEdge = anEdge;
-
-		if (aClosestInd <= aNbPnts) {
-		  aPInter = anIntersector.Point(aClosestInd);
-		} else {
-		  aClosestInd -= aNbPnts;
-
-		  if (aClosestInd&1) {
-		    aPInter =  anIntersector.
-		      Segment((aClosestInd + 1)/2).FirstPoint();
-		  } else {
-		    aPInter =  anIntersector.
-		      Segment((aClosestInd + 1)/2).LastPoint();
-		  }
-		}
-
-		myPosition      = aPInter.
-		                  TransitionOfSecond().PositionOnCurve();
-		myEdgeParameter = aPInter.ParamOnSecond();
-	      }
-	      // if we are ON, we stop
-	      aState = myClassifier.State();
-	    
-	      if (aState == TopAbs_ON)
-		return;
-	    }
-	  }
-	}
-
-	// if we are out of the wire we stop
-	aState = myClassifier.State();
-
-	if (aState == TopAbs_OUT)
-	  return;
+  TopClass_FClass2d aClassifier;
+
+  //These two constants are entered in order to speeding up the performance.
+  unsigned int aMaxWeight = UINT_MAX;
+  const Standard_Real aMaxDelta = 0.01;
+
+  Standard_Boolean hasWires = Standard_False;
+  TopClass_RayInfo aRayInfo;
+
+  theFExp.FirstRay(aPoint, aRayInfo);
+  Standard_Real aRealInterval = aRayInfo.MinDeltaInterval();
+
+  do
+  {
+    aClassifier.Reset(aRayInfo.GetLine(), aRayInfo.GetParameter());
+
+    for (theFExp.InitWires(); theFExp.MoreWires(); theFExp.NextWire())
+    {
+      // Counts penalties added by TheFaceExplorer::IsPointInEdgeVertex(...) method
+      unsigned int aSumPenaltyVertCoinc = 0;
+
+      // test this wire
+      for (theFExp.InitEdges(); theFExp.MoreEdges(); theFExp.NextEdge())
+      {
+        // Empty face is possible:
+        //    plane pl 0 0 0 0 0 1
+        //    mkface ff pl
+        // As result, ff does not contain any wires/edges/vertices.
+        // However, Geom2dHatch_Classifier (which is used by DBRep_IsoBuilder)
+        // returns some wire but does not find any edge. Therefore, "hasWires"
+        // flag should be put to the current "edges"-cycle (not outer "wires"-cycle).
+        hasWires = Standard_True;
+        
+        // test this edge
+        theFExp.CurrentEdge(anEdge);
+        if ((anEdge.GetOrientation() != TopAbs_FORWARD) &&
+            (anEdge.GetOrientation() != TopAbs_REVERSED))
+        {
+          continue;
+        }
+
+        //Intersects with anEdge
+        aClassifier.Compare(anEdge, theTol2D);
+        aClosestInd = aClassifier.ClosestIntersection();
+
+        if (aClosestInd != 0)
+        {
+          // save the closest edge
+          TheIntersection2d &anIntersector = aClassifier.Intersector();
+          Standard_Integer  aNbPnts = anIntersector.NbPoints();
+
+          myEdge = anEdge;
+
+          if (aClosestInd <= aNbPnts)
+          {
+            aPInter = anIntersector.Point(aClosestInd);
+          }
+          else
+          {
+            aClosestInd -= aNbPnts;
+
+            //Tangential case
+            aRayInfo.AddPenalty(2);
+
+            if (aClosestInd & 1) {
+              aPInter = anIntersector.
+                Segment((aClosestInd + 1) / 2).FirstPoint();
+            }
+            else
+            {
+              aPInter = anIntersector.
+                Segment((aClosestInd + 1) / 2).LastPoint();
+            }
+          }
+
+          const gp_Pnt2d &aPOnC = aPInter.Value();
+          if (theFExp.IsPointInEdgeVertex(aPOnC))
+          {
+            const unsigned int aPenaltyVal = 5u;
+            aSumPenaltyVertCoinc += aPenaltyVal;
+            aRayInfo.AddPenalty(aPenaltyVal);
+          }
+
+          aRayInfo.AddParamOnLine(aPInter.ParamOnFirst());
+
+          myEdgeParameter = aPInter.ParamOnSecond();
+        }
+        
+        if ((aClassifier.State() == TopAbs_ON) &&
+            (aRayInfo.GetWeight() == aSumPenaltyVertCoinc))
+        {
+          // if we are ON, we stop. In case only if we can trust this info.
+          // In case of ON-status we can trust the ray going through the edge vertex.
+          myState = TopAbs_ON;
+          return;
+        }
+      }
+
+      if (aRayInfo.MinDeltaInterval() < aMaxDelta)
+      {
+        aRayInfo.AddPenalty();
+      }
+
+      aRayInfo.SetState(aClassifier.State());
+
+      if ((aRayInfo.GetState() == TopAbs_OUT) && (aRayInfo.GetWeight() == 0))
+      {
+        // If we are out of the wire we stop. In case only if we can trust this info.
+        myState = TopAbs_OUT;
+        return;
       }
     }
 
-    if (!myClassifier.IsHeadOrEnd() && aState != TopAbs_UNKNOWN)
-      break;
+    if ((aClassifier.State() != TopAbs_UNKNOWN) && ((myState == TopAbs_UNKNOWN) ||
+                                                    (aRayInfo.GetWeight() <= aMaxWeight)))
+    {
+      if (aRayInfo.GetWeight() < aMaxWeight)
+      {
+        aMaxWeight = aRayInfo.GetWeight();
+        aRealInterval = aRayInfo.MinDeltaInterval();
+        myState = aClassifier.State();
+      }
+      else if (aRayInfo.MinDeltaInterval() >= aRealInterval)
+      {
+        myState = aClassifier.State();
+        aRealInterval = aRayInfo.MinDeltaInterval();
+      }
+      else if (myState == TopAbs_UNKNOWN)
+      {
+        myState = aClassifier.State();
+      }
+      
+      if (!aClassifier.IsHeadOrEnd() && (aRayInfo.GetWeight() == 0))
+      {
+        myState = aClassifier.State();
+        return;
+      }
+    }
+  }
+  while (hasWires && 
+         ((aRayInfo.GetWeight() != 0) || (myState == TopAbs_UNKNOWN)) &&
+         theFExp.OtherRay(aPoint, aRayInfo, aMaxWeight));
 
-    // Bad case for classification. Trying to get another segment.
-    IsValidSegment = Fexp.OtherSegment(aPoint, aLine, aParam);
+  if (!hasWires)
+  {
+    myState = TopAbs_IN;
+    return;
   }
 }
 
@@ -159,33 +213,6 @@ void TopClass_FaceClassifier::Perform(TheFaceExplorer& Fexp,
 
 TopAbs_State TopClass_FaceClassifier::State() const
 {
-  if (rejected)     return TopAbs_OUT;
-  else if (nowires) return TopAbs_IN;
-  else              return  myClassifier.State();
-}
-
-//=======================================================================
-//function : Edge
-//purpose  : 
-//=======================================================================
-
-const TheEdge& TopClass_FaceClassifier::Edge() const
-{
-  Standard_DomainError_Raise_if(rejected,
-				"TopClass_FaceClassifier::Edge:rejected");
-  return myEdge;
-}
-
-
-//=======================================================================
-//function : EdgeParameter
-//purpose  : 
-//=======================================================================
-
-Standard_Real TopClass_FaceClassifier::EdgeParameter() const
-{
-  Standard_DomainError_Raise_if(rejected,
-				"TopClass_FaceClassifier::EdgeParameter:rejected");
-  return myEdgeParameter;
+  return myState;
 }
 
